/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */     
package multithreading2;

import java.awt.Color;
import java.util.Random;
import java.awt.Graphics;


/**
 *
 * @author claudiu
 */
public class Particula {
    protected int x;
    protected int y;
    protected boolean capturata = false;
    protected final Random rand = new Random();
    private final int initialX;
    private final int initialY;
    
    
    public Particula(int initX, int initY) {
        x = initX;
        y = initY;
        initialX = initX;
        initialY = initY;
    }
    
    public boolean getCaptura() {
        return capturata;
    }
    
    public synchronized void setCaptura(boolean stare) {
        capturata = stare;
    }
        
    public synchronized int move() {
        int value = 0;
        
        x += rand.nextInt(20) - 10;
        if (x <= 0 || x >= 300) {
            x = initialX;
            value = 1;
            setCaptura(true);
        }
        
        y += rand.nextInt(30) - 15;
        if (y <= 0 || y >= 300) {
            y = initialY;
            value = 2;
            setCaptura(true);
        }
        
        return value;
    }
    
    public synchronized void freeMove() {      
        x += rand.nextInt(10) - 5;
        y += rand.nextInt(20) - 10;
    }
    
    public void draw(Graphics g) {
        int lx, ly;
        
        synchronized (this) { 
            lx = x; ly = y; 
        }
        g.setColor(Color.ORANGE);
        g.fillRect(lx, ly, 7, 7);
    }
}
